package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_STATI_PIANIFIC_FERIE")
public class DstatiPianificFerie extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 1574357390L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DstatiPianificFerie.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_STATO_PIANIFIC_FERIE", columnDefinition = "NUMBER(15)")
	private Long sequIdStatoPianificFerie;
	@NotNull

	@Column(name = "CODI_STATO_PIANIFICAZIONE", columnDefinition = "VARCHAR(50)")
	private String codiStatoPianificazione;
	@NotNull

	@Column(name = "DESC_STATO_PIANIFICAZIONE", columnDefinition = "VARCHAR(250)")
	private String descStatoPianificazione;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DstatiPianificFerie(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DstatiPianificFerie(DstatiPianificFerieKey dstatiPianificFerieKey, Long sequIdStatoPianificFerie,
			String codiStatoPianificazione, String descStatoPianificazione, String flagEliminato,
			String utenteUltimaModifica, Date dataUltimaModifica, Date dataInizioRecord, Date dataFineRecord) {
		super();

		this.dstatiPianificFerieKey = dstatiPianificFerieKey;

		this.sequIdStatoPianificFerie = sequIdStatoPianificFerie;
		this.codiStatoPianificazione = codiStatoPianificazione;
		this.descStatoPianificazione = descStatoPianificazione;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDstatiPianificFerie")
	@OneToMany(mappedBy = "theDstatiPianificFerie", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DpianificFerieAmmto> theDpianificFerieAmmto = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdStatoPianificFerie
	 */
	public Long getSequIdStatoPianificFerie() {
		return this.sequIdStatoPianificFerie;
	}

	/**
	 * @param sequIdStatoPianificFerie to set
	 */
	public void setSequIdStatoPianificFerie(Long sequIdStatoPianificFerie) {
		this.sequIdStatoPianificFerie = sequIdStatoPianificFerie;
	}

	/**
	 * @return the codiStatoPianificazione
	 */
	public String getCodiStatoPianificazione() {
		return this.codiStatoPianificazione;
	}

	/**
	 * @param codiStatoPianificazione to set
	 */
	public void setCodiStatoPianificazione(String codiStatoPianificazione) {
		this.codiStatoPianificazione = codiStatoPianificazione;
	}

	/**
	 * @return the descStatoPianificazione
	 */
	public String getDescStatoPianificazione() {
		return this.descStatoPianificazione;
	}

	/**
	 * @param descStatoPianificazione to set
	 */
	public void setDescStatoPianificazione(String descStatoPianificazione) {
		this.descStatoPianificazione = descStatoPianificazione;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DpianificFerieAmmto
	 */
	public Collection<DpianificFerieAmmto> getTheDpianificFerieAmmto() {
		return theDpianificFerieAmmto;
	}

	/**
	 * @param aDpianificFerieAmmtoList to set
	 */
	public void setTheDpianificFerieAmmto(Collection<DpianificFerieAmmto> aDpianificFerieAmmtoList) {
		theDpianificFerieAmmto = aDpianificFerieAmmtoList;
	}

	/// ADD CHILD
	public void addDpianificFerieAmmto(DpianificFerieAmmto dpianificFerieAmmto) {
		theDpianificFerieAmmto.add(dpianificFerieAmmto);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDstatiPianificFerieKey());
	}

	public String getObjectKeyById(DstatiPianificFerieKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dstatiPianificFerieKey = new DstatiPianificFerieKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiStatoPianificazione());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DstatiPianificFerieKey dstatiPianificFerieKey;

	// GETTER/SETTER CK
	/**
	 * @return the dstatiPianificFerieKey
	 */
	public DstatiPianificFerieKey getDstatiPianificFerieKey() {
		return this.dstatiPianificFerieKey;
	}

	/**
	 * @param dstatiPianificFerieKey to set
	 */
	public void setDstatiPianificFerieKey(DstatiPianificFerieKey dstatiPianificFerieKey) {
		this.dstatiPianificFerieKey = dstatiPianificFerieKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dstatiPianificFerieKey == null) {
			dstatiPianificFerieKey = new DstatiPianificFerieKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DstatiPianificFerie that = (DstatiPianificFerie) o;
		return dstatiPianificFerieKey != null && Objects.equals(dstatiPianificFerieKey, that.dstatiPianificFerieKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dstatiPianificFerieKey);
	}
}
